<?php
/**
 * Created by PhpStorm.
 * User: marcel
 * Date: 21.06.17
 * Time: 10:46
 */

$dataDir = $this->getPath('data');
		if(is_dir($dataDir) && !is_dir(rex_path::addonData($this->getName()))) {
			if(!rex_dir::copy($dataDir,rex_path::addonData($this->getName()))) {
				throw new rex_functional_exception($this->i18n('install_cant_copy_files'));
			}
		}

		$filetypes = ['webp' => ['name' => 'webp', 'data' => '"rex_effect_webp": {"rex_effect_webp_quality":"85"}"'],
			'' => ''];
		$sizes     = ['xs' => '380', 'sm' => '540', 'md' => '720', 'lg' => '960', 'xl' => '1140'];

		$types = [
			'teaser_xs'             => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
				'resize'       => '"rex_effect_resize": { "rex_effect_resize_width": "768px", "rex_effect_resize_height": "", "rex_effect_resize_style": "maximum", "rex_effect_resize_allow_enlarge": "not_enlarge"}'
			],
			'teaser_sm'             => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
				'resize'       => '"rex_effect_resize": { "rex_effect_resize_width": "992px", "rex_effect_resize_height": "", "rex_effect_resize_style": "maximum", "rex_effect_resize_allow_enlarge": "not_enlarge"}'
			],
			'teaser_md'             => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
				'resize'       => '"rex_effect_resize": { "rex_effect_resize_width": "1200px", "rex_effect_resize_height": "", "rex_effect_resize_style": "maximum", "rex_effect_resize_allow_enlarge": "not_enlarge"}'
			],
			'teaser_source'         => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
			],
			'tinymcewysiwyg_xs'     => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
				'resize'       => '"rex_effect_resize": { "rex_effect_resize_width": "760px", "rex_effect_resize_height": "", "rex_effect_resize_style": "maximum", "rex_effect_resize_allow_enlarge": "not_enlarge"}'
			],
			'tinymcewysiwyg_sm'     => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
				'resize'       => '"rex_effect_resize": { "rex_effect_resize_width": "900px", "rex_effect_resize_height": "", "rex_effect_resize_style": "maximum", "rex_effect_resize_allow_enlarge": "not_enlarge"}'
			],
			'tinymcewysiwyg_md'     => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
				'resize'       => '"rex_effect_resize": { "rex_effect_resize_width": "1200px", "rex_effect_resize_height": "", "rex_effect_resize_style": "maximum", "rex_effect_resize_allow_enlarge": "not_enlarge"}'
			],
			'tinymcewysiwyg_source' => [
				'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
			]
		];


		foreach($filetypes as $f => $f_effect) {
			foreach($sizes as $s_name => $s) {
				$types['default'.($s_name != '' ? '-'.$s_name : '').($f != '' ? '_'.$f : '')] = [
					'cachecontrol' => '"rex_effect_cachecontrol":{"rex_effect_cachecontrol_cachecontrol":"default"}',
					'resize'       => '"rex_effect_resize": { "rex_effect_resize_width": "'.$s.'px", "rex_effect_resize_height": "", "rex_effect_resize_style": "maximum", "rex_effect_resize_allow_enlarge": "not_enlarge"}'
				];
				if(is_array($f_effect))
					$types['default'.($s_name != '' ? '-'.$s_name : '')][$f_effect['name']] = $f_effect['data'];
			}
		}


$typeNames = array_keys($types);
$typeNames = '"'.join('", "', $typeNames).'"';

$sql = rex_sql::factory();
$sql->setQuery('DELETE FROM rex_media_manager_type_effect where type_id in (select id from rex_media_manager_type where name in ('.$typeNames.'))');
$sql->setQuery("DELETE FROM rex_media_manager_type where name in (".$typeNames.")");


foreach($types as $typeName => $effects) {
    $sql->prepareQuery('Insert into rex_media_manager_type (status, name) VALUES (0, ?)');
    $sql->execute([$typeName]);
    $typeId = $sql->getLastId();

    $priority = 0;
    $createdate = date('Y-m-d H:i:s');
    foreach($effects as $effectName => $effectValue) {
        $sql->prepareQuery('Insert into rex_media_manager_type_effect (type_id, effect, parameters, priority, createdate, createuser) VALUES (?, ?, ?, ?, ?, ?)');
        $sql->execute([$typeId, $effectName, '{'.$effectValue.'}', ++$priority, $createdate, 'administrator']);
    }
}