<?php
/**
 * Created by PhpStorm.
 * User: markus
 * Date: 07.02.18
 * Time: 13:54
 */

class optimizer extends MM_auto
{
    public static function rimage($filename, $alt, $class = '', $params = '') {
        if(!isset($_COOKIE['PHPSESSID']))
		    header("link: <".self::base_url().$filename.">; rel=preload; as=image;", false);
        return '<img src="'.$filename.'" alt="'.$alt.'"'.($class != '' ? ' class="'.$class.'"' : '').' '.$params.' />';
    }

	public static function image($filename = '', $type = '', $alt = '', $class='', $params='') {
	    if($type == null || '') $type = 'default';

		$src = '<picture>';
		$src .= self::imageSrcSet($filename, $type);
		$src .= '<img src="'.self::rewrite($filename, $type.'-org').'" alt="'.$alt.'"  class="'.$class.'" '.$params.'>';
		$src .= '</picture>';
		return $src;
	}

	public static function getHashedFile($filename) {
		$string = file_get_contents("resources/dist/assets.json");
		$string = json_decode($string);

		return $string->$filename;
    }

	public static function imageSrcSet($filename, $type) {
		if($type == null || '') $type = 'default';

		$m = rex_media::get($filename);

//		$filetypes = ['webp' => 'image/webp', 'jp2' => 'image/jp2', 'jpx' => 'image/jpx', $m->getExtension() => $m->getType()];
		if(!is_object($m))
			return '';

		$filetypes = [$m->getExtension() => $m->getType()];
		$sizes     = ['xs' => 'max-width: 380px', 'sm' => 'max-width: 540px', 'md' => 'max-width: 720px', 'lg' => 'max-width: 960px', 'xl' => 'min-width: 1140px'];

		$srcset = '';

		if($m->getExtension() == 'png' || $m->getExtension() == 'jpg') {
			unset($filetypes['jp2']);
		}
		foreach($sizes as $size_name => $size) {
			foreach($filetypes as $ft => $ft_type) {
			    if($size === end($sizes)) {
					if(!isset($_COOKIE['PHPSESSID']))
					    header("link: <".self::base_url().self::rewrite($filename, $type.'-'.$size_name.($m->getExtension() == $ft ? '' : '_'.$ft)).">; rel=preload; as=image;", false);
                }
				$srcset .= '<source srcset="'.self::base_url().self::rewrite($filename, $type.'-'.$size_name.($m->getExtension() == $ft ? '' : '_'.$ft)).'" media="('.$size.')" type="'.$ft_type.'">';
			}
		}

		return $srcset;
	}

	public static function getHeader($content = '', $css = [], $js = []) {
		self::setLang();
		header('Content-Type: text/html; charset=utf-8');
		header( 'Cache-Control: max-age=604800' );
		self::getHead($content, $css, $js);
	}

	public static function setLang() {
		if(!isset($_SESSION['lang'])) {
			$supportedLangs = array();
			foreach(rex_clang::getAll() as $lang) {
				$supportedLangs[$lang->getId()] = $lang->getCode();
			}

			if(isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
				$languages = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);

				$current_clang = rex_clang::getCurrent()->getCode();
				foreach($languages as $lang => $clangid) {
					foreach($supportedLangs as $slang_id => $slang_code) {
						if($slang_code == $clangid) {
							if($slang_code != $current_clang) {
								$_SESSION['lang'] = $slang_id;
								rex_redirect(null, $slang_id);
							}
							break;
						}
					}
				}
			}
			$_SESSION['lang'] = '';
		}
	}

	public static function base_url($withoutfolder = false) {
		return (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != '' ? 'https' : 'http').'://'.$_SERVER['SERVER_NAME'].($_SERVER['SERVER_NAME'] == 'localhost' ? ':20080' : '').($withoutfolder == false ? rex_url::frontend() : '');
    }

	public static function getHead($content, $css = [], $js = []) {
		?>
<!DOCTYPE html>
<html lang="<?php echo rex_clang::getCurrent()->getCode(); ?>" dir="ltr">
<head>
	<meta charset="UTF-8">
	<base href="<?=self::base_url();?>">
	<meta name="viewport" content="width=device-width, initial-scale=1, viewport-fit=cover">
	<link rel="alternate" hreflang="x-default" href="<?=self::base_url();?>">
	<link rel="icon" type="image/png" href="resources/img/favicon.png">
	<link rel="icon" type="image/x-icon" href="resources/img/favicon.ico">
<?php
		// Keywords and description
		// Wenn der aktuelle Artikel kein Keyword und Description besitzt, werden die aus dem Startartikel genommen
		if(rex_article::getCurrent()->getValue("art_keywords")) {
			$keywords = rex_article::getCurrent()->getValue("art_keywords");
		} else {
			$home = new rex_article_content(rex_article::getSiteStartArticleId());
			$keywords = $home->getValue('art_keywords');
		}
		echo "\t".'<meta name="keywords" content="' . htmlspecialchars($keywords) . '">' . PHP_EOL;
		$seo = new rex_yrewrite_seo();

		echo "\t".$seo->getTitleTag() . PHP_EOL;
		echo "\t".$seo->getDescriptionTag() . PHP_EOL;
		echo "\t".$seo->getRobotsTag() . PHP_EOL;
		echo "\t".$seo->getCanonicalUrlTag() . PHP_EOL; ?>

	<link rel="icon" type="image/x-icon" href="<?=self::base_url();?>resources/img/favicon.ico">
	<link rel="icon" type="image/png" href="<?=self::base_url();?>resources/img/favicon.png">
<?php
		self::getAlternateTags().PHP_EOL;
		echo $content.PHP_EOL;

		foreach($css as $cssfile) {
			if(!isset($_COOKIE['PHPSESSID']))
			    header("link: <".self::base_url().$cssfile.">; rel=preload; as=style;", false);
			echo PHP_EOL.'<link rel="stylesheet" href="'.self::base_url().$cssfile.'">';
        }
        foreach($js as $jsfile => $zusatz) {
			if(!isset($_COOKIE['PHPSESSID']))
			    header("link: <".self::base_url().$jsfile.">; rel=preload; as=script;", false);
			echo PHP_EOL.'<script content-type="text/javascript" src="'.self::base_url().$jsfile.'" '.$zusatz.'></script>';
        }
		?>
	</head>
<?php
	}

	public static function getAlternateTags() {
		$a = rex_clang::getAll();
		foreach($a as $b) {
			if($b->getId() != rex_clang::getCurrentId() && $b->isOnline()) {
				echo "\t".'<link rel="alternate" hreflang="'.$b->getCode().'" href="'.self::base_url(true).rex_article::getCurrent($b->getId())->getUrl().'" type="text/html" />'.PHP_EOL;
			}
		}
	}
}

