<?php
/**
 * Created by PhpStorm.
 * User: markus
 * Date: 27.03.19
 * Time: 13:54
 */

class rex_onepager {

	public static function load($ep) {
		if(self::isOnline() && isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
			$a = rex_article::getCurrent();
			$template = self::getCleanTemplate($a->getTemplateId());

			$vars = self::getRexVarArray($template);

			$templateids = self::getEachTemplate($vars);
			$erg = self::getTemplate($templateids);

			$a = new rex_article_content($a->getId(), $a->getClang());

			$erg['REX_ARTICLE'] = ['content' => $a->getArticle(), 'id' => rex_onepager_config::get('template_content_id')];

			header('Content-Type: application/json');

			echo json_encode($erg);

			die();
		}
	}

	public static function outputscripts($ep) {
		$content = $ep->getSubject();

		if(self::isOnline()) {
			$scripts = PHP_EOL . '<script content-type="text/javascript" src="assets/addons/cachehelper/plugins/onepager/onepager.js" defer="defer"></script>' . PHP_EOL . '</head>';
			$content = str_replace('</head>', $scripts, $content);
		}
		echo $content;
		die(); // $content;
	}

	public static function getTemplate($templateids, $old = []) {
		$erg = [];
		$erg = array_merge($old, $erg);

		$cfg = self::getConfigArray(true);
		print_r($cfg);
		foreach($templateids as $templateid) {
			if(isset($cfg[$templateid])) {
				$template = self::getCleanTemplate($templateid);

				$vars = self::getRexVarArray($template);
				$templateids2 = self::getEachTemplate($vars);
				if(is_array($templateids2) && sizeof($templateids2) > 0) $erg = self::getTemplate($templateids2, $erg);

				ob_get_clean();
				ob_start();
				$a2 = new rex_article_content();
				$a2->setArticleId(rex_article::getCurrent());
				echo rex_var_template::getTemplateOutput(require rex_var_template::getTemplateStream($templateid, $a2));
				$content = ob_get_contents();
				ob_get_clean();
				$id = rex_onepager_config::get($cfg[$templateid].'_id');
				$erg['TEMPLATE_' . $templateid] = ['id' => $id, 'content' => $content];
			}
		}
		return $erg;
	}

	public static function getConfigArray($getOnlyTemplateIds = false) {
		$sql = rex_sql::factory();
		$sql->setQuery('Select * from '.rex::getTablePrefix().'config where namespace="cachehelper/onepager"'.($getOnlyTemplateIds == true ? ' and `key` like "template_%" and `key` not like "template_%_id"' : ''));

		$erg = [];
		for($i = 0; $i <= $sql->getRows(); $i++) {
			$a = str_replace('"', '', $sql->getValue('value'));
			$erg[$a] = $sql->getValue('key');
			$sql->next();
		}
		return $erg;
	}

	public static function getCleanTemplate($templateid) {
		$sql = rex_sql::factory();
		$qry = 'SELECT content FROM ' . rex::getTablePrefix()  . 'template WHERE id = ' . $templateid;
		$sql->setQuery($qry);

		if ($sql->getRows() == 1) {
			return $sql->getValue('content');
		}
		return false;
	}

	public static function getRexVarArray($content) {
		preg_match_all('/(REX_[A-Z_]+)\[((?:[^\[\]]|\\\\[\[\]]|(?R))*)(?<!\\\\)\]/s', $content, $matches, PREG_SET_ORDER);
		return $matches;
	}

	public static function getEachTemplate($matches) {
		$erg = array();
		foreach($matches as $id => $arr) {
			if(isset($arr[1]) && $arr[1] == 'REX_TEMPLATE') {
				$erg[] = $arr[2];
			}
		}
		return $erg;
	}

	public static function isOnline($clang = null, $default = null) {
		if($clang == null) $clang = rex_clang::getCurrent()->getCode();

		$key = 'onepager-on';
		$value = rex_onepager_config::get($key, $default);
		return ($value == '1' ? true : false);
	}

	public static function cfg($key, $format = null, $default = '', $clang = null) {
		if($clang == null) $clang = rex_clang::getCurrent()->getCode();

		$key = $clang.'_'.$key;
		$value = rex_onepager_config::get($key, $default);
		if($format) {
			if($format === 'phone') {
				return 'tel:'.preg_replace('( |\(0\)|\(|\)|-)', '', $value);
			} elseif($format === 'link') {
				return rex_getUrl($value);
			}
		} else {
			return $value;
		}
	}
}